/*
** au rue
*/


var SSProtocol = #1={

	scheme: "ss",
	ProtocolName: "SessionSaver Protocol",
	get ContractID() { return "@mozilla.org/network/protocol;1?name="+this.scheme; },
	cid: Components.ID("{799509b9-2e3b-4682-a5d1-71ca80a76456}"),
 	defaultPort: -1,
	protocolFlags: Components.interfaces.nsIProtocolHandler.URI_NORELATIVE,// | Components.interfaces.nsIProtocolHandler.URI_NOAUTH,
 
	load: function() {
		this.console   = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		this.ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		this.SSBaseURI = this.ioService.newURI("chrome://sessionsaver/content/", null, null);
		var compMgr    = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactory(this.cid, this.ProtocolName, this.ContractID, this.Factory);
	},
	allowPort: function(port, scheme) { return false; },
	newURI: function(spec, charset, baseURI) {
		//this.console.logStringMessage("SSProtocol.newURI: "+spec+" "+charset+" "+(baseURI?baseURI.spec:null));
		var uri = Components.classes["@mozilla.org/network/simple-uri;1"].createInstance(Components.interfaces.nsIURI);
		try{ uri.spec = spec; }
		catch(e) { this.console.logStringMessage("SSProtocol.newURI failed: "+spec+" \n "+e); }
		return uri;
		//return this.ioService.newURI(this.SSBaseURI.resolve(spec), null, null);
	},
	// Restore "?" "&" and "=" (since dock() escaped them)
	ampRe: new RegExp(escape("&"),"g"),   eqRe: new RegExp(escape("="),"g"),   pRe: new RegExp(escape("#"),"g"),   qRe: new RegExp(escape("?"),"g"),
	unescape: function(string) {
		return (string && string.replace) ? string/*.replace(this.qRe,"?")*/.replace(this.ampRe,"&").replace(this.eqRe,"=").replace(this.pRe,"#") : string; // "\%3\F" -> %3F
	},
	newChannel: function(locationURI) {
		var params = locationURI.spec.replace(new RegExp(this.scheme+":"), "").split("#");
		var paramObj = {url:this.unescape(params[0]), name:null, width:500, height:500, flags:null, referrer:null}; // url is *always* first -- and unkeyed
		//var x = params.shift(); if (x && x!="#") params.unshift(x); // ditch the "#" anchor, if present
		if (params[1]) {
			params = params[1].split("&");
			while ((p=params.shift())) {
				var p = p.split("="),   key=p[0], value=p[1];
				paramObj[key] = this.unescape(value); }
		}
		if (!/(^\/)|\:/.test(paramObj.url)) paramObj.url = "http://"+paramObj.url; // XXX test for "/groups.google.com" and "groups.google.com"
		
		//encodeURI(mySearchTerm);
		
		// http://lxr.mozilla.org/seamonkey/source/netwerk/protocol/about/src/nsAboutBlank.cpp#46 // the "about:blank" html-stream
		// http://lxr.mozilla.org/seamonkey/source/netwerk/base/public/nsNetUtil.h#287 // how the stream is created
		// http://www.xulplanet.com/references/xpcomref/comps/c_networkinputstreamchannel1.html // the js-form of the nsNetUtil-code
		
		// Note: initWindowDrag() is defined in windowDrag.js
		var iTitle = "Popup"; // "interim" title -- until the popup-iframe loads
		if (paramObj.referrer) iTitle += ": "+(this.ioService.newURI(paramObj.referrer, null, null).host.replace(/^www\./, ""));
		var pageString = "\
				<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>\
				<html><head><title>"+iTitle+"</title>\
					<!-- XXX should link ss:ssWindowDrag.js, since chrome-access from content is/should-be/will-be disabled, in future-firefox -->\
					<script src='chrome://sessionsaver/content/ssWindowDrag.js'></script>\
					<script>\
						var Protocol = '"+this.scheme+":';\
						var paramObj = "+paramObj.toSource()+";\
						var titleDiv, mainFrame, scriptFrame;\
						function init() { initWindowDrag();\
								titleDiv = all['ManualCenter'];\
								mainFrame = document.getElementById('ss-popup-iframe');\
									/* XXX unless we 're-define' the channel-location as chrome, this context is Un-privileged for pretty much everything, cross-site/frame -- see below, per the channel's locationURI */\
								mainFrame.addEventListener('load',onloadWrap,true);\
								window.addEventListener('click',onclickWrap,true);\
								all['ManualResize'].sizeTo("+parseInt(paramObj.width)+","+parseInt(paramObj.height)+");\
								all['ManualCenter'].center();\
								document.getElementById('drag-load-hide').style.visibility='visible'; }\
						function onloadWrap(){setTimeout('onload()')};\
						function onclickWrap(){setTimeout('onclick()')};\
						function onload(evt) { /* oddly, only .currentTarget shows for targeting.. */ \
							/* ..apparently, this listener only trips for frame-complete loads */\
							top.document.title = titleDiv.innerHTML = mainFrame.contentDocument.title;\
							paramObj.url = escapeM(''+mainFrame.contentWindow.location);\
							changeTopUrl(); }\
						function onclick(evt) {\
							var width = parseInt(this.contentWindow.getComputedStyle(mainFrame,'width').width);\
							var height = parseInt(this.contentWindow.getComputedStyle(mainFrame,'height').height);\
							if (width==paramObj.width && height==paramObj.height) return;\
							paramObj.width=width, paramObj.height=height;\
							changeTopUrl(); }\
						function changeTopUrl() {\
							var newArray = [paramObj.url];\
							for (var n in paramObj) if (n != 'url' && paramObj[n] != null) newArray.push(n+'='+this.escapeM(paramObj[n]));\
							newArray.length>0 && newArray.unshift('#');\
							window.location = Protocol+newArray.join('&'); }\
						var ampRe=new RegExp(escape('&'),'g'),   eqRe=new RegExp(escape('='),'g'),   pRe=new RegExp(escape('#'),'g'),   qRe=new RegExp(escape('?'),'g');\
						var amp=escape('&'),   eq=escape('='),   p=escape('#'),   q=escape('?');\
						function escapeM(string) {\
							if (string && string.replace) string = string/*.replace(qRe,q)*/.replace(ampRe,amp).replace(eqRe,eq).replace(pRe,p); /* '\%3\F' -> %3F */ \
							return string; }\
					</script>\
				</head><body>\
					<span style='display:block; height:0; width:0; visibility:hidden !important;'> hidden text -- invokes necessary repaint for our new content</span>\
					<span id='drag-load-hide' style='visibility:hidden;'>\
						<div id='outer' style='position:absolute; width:100px; height:100px; clip:rect(0 100 100 0); z-Index:1; top:50px; left:50px;  background:#aaa; layer-background-color:#aaa;'></div>\
						<div id='title' style='position:absolute; width:94px; height:10px; clip:rect(0 94 10 0); z-Index:2; top:53px; left:53px; background:#55d; layer-background-color:#55d; font: bold 10px/10px Verdana, Geneva, Arial, Helvetica, sans-serif; color: #fff; cursor: move;'>"+iTitle+"</div>\
						<div id='inner' style='position:absolute; width:94px; height:82px; clip:rect(0 94 82 0); z-Index:3; top:65px; left:53px; overflow:hidden; background:#eee; layer-background-color:#eee;'>\
							<div style='max-width:100%; max-height:0px; width:inherit; height:inherit; margin: 0px; padding: 0px; overflow: visible;'>\
								<iframe id='ss-popup-iframe' src='"+paramObj.url+"' "+paramObj.flags+" style='width:inherit; height:inherit; display:block; position:relative; top:0; left:0; z-index:2;' > </iframe>\
							</div>\
							<span id='drag-overlay' style='width:inherit; height:inherit; display:block; position:relative; top:0; left:0; z-index:3; XXX-moz-opacity: 0.75; background-color: none; font-family:Times,Serif; font-size:56pt; font-style:italic; display:none;'><span id='drag-resize-text' style='padding-right:30px; padding-top:10px; -moz-opacity:0.30; display:none;'>s.s.</span><span id='drag-move-text' style='padding-right:30px; padding-top:10px; -moz-opacity:0.30; display:none;'>s.s.</span></span>\
						</div>\
						<div id='size' style='position:absolute; width:20px; height:20px; clip:rect(0 20 20 0); z-Index:2; top:130px; left:130px; background:#555; layer-background-color:#555; cursor:nw-resize;'></div>\
					</span>\
					<script>init();</script>\
				</body></html>";
		pageString = pageString.replace(/\t+/g, "");
		
		var inputStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
		inputStream.setData(pageString, -1);
		var iStreamChannel = Components.classes["@mozilla.org/network/input-stream-channel;1"].createInstance();
		//iStreamChannel.QueryInterface(Components.interfaces.nsIInputStreamChannel).setURI(locationURI);
		locationURI.spec = "chrome://sessionsaver/content/generated-x";
		iStreamChannel.QueryInterface(Components.interfaces.nsIInputStreamChannel).setURI(locationURI);
		iStreamChannel.QueryInterface(Components.interfaces.nsIInputStreamChannel).contentStream = inputStream;
		iStreamChannel.QueryInterface(Components.interfaces.nsIChannel).contentLength = -1;
		iStreamChannel.QueryInterface(Components.interfaces.nsIChannel).contentType = "text/html";
		iStreamChannel.QueryInterface(Components.interfaces.nsIChannel).contentCharset = "";
		
		return iStreamChannel;
		
	},
	
	QueryInterface: function(iid) {
		if (!iid.equals(Components.interfaces.nsIProtocolHandler) &&
			!iid.equals(Components.interfaces.nsISupports))
			throw Components.results.NS_ERROR_NO_INTERFACE;
		return this;
	},
	Factory: #2={
		 createInstance: function(outer, iid) {
			if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
			return SSProtocol;
		},
		QueryInterface: function(iid) {
			if (!iid.equals(Components.interfaces.nsISupports) &&
				!iid.equals(Components.interfaces.nsISupportsWeakReference) &&
				!iid.equals(Components.interfaces.nsIFactory))
				throw Components.results.NS_ERROR_NO_INTERFACE;
			return this;
		}
	},
	FactoryParent: #2#.parent=#1#
	
};



/*
** fire -!
*/

SSProtocol.load();